﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace LinqToCsv
{
    class Program
    {
        static void Main(string[] args)
        {
            Methode1();
            Console.ReadLine();

            Methode2();
            Console.ReadLine();
        }


        // Simple string split, using just first 3 fields, 
        // generating a single string with padded items, using LINQ To Object. 
        private static void Methode1()
        {
            string[] lines = File.ReadAllLines("Export Sales Info-demo.csv");
            var t1 = lines
                .Where(l => !l.StartsWith("#"))
                .Select(l => l.Split(','))
                .OrderBy(items=>items[0])
                .Select(items => String.Format("{0}{1}{2}",
                    items[1].PadRight(15),
                    items[2].PadRight(30),
                    items[3].PadRight(10)));
            var t2 = t1
                .Select(l => l.ToUpper());
            foreach (var t in t2.Take(5))
                Console.WriteLine(t);

        }

        // Using class helper to split strings, using LINQ to Object to create output
        private static void Methode2()
        {
            var data = File.ReadAllLines("Export Sales Info-demo.csv").Where(s=>!s.StartsWith("#"))
                .Select(l =>
            {
            var split = l.CsvSplit();
            return new
                       {
                           Contact = split[0],
                           City = split[1],
                           Company = split[2]
                       };
            }  ).OrderBy(x=>x.Contact);

            foreach (var d in data.Take(5))
                Console.WriteLine(d);
        }


    }
}
